/**
 *
 * @author Giorgio
 */

import java.lang.*;
import java.util.*;

class LibroEsistente extends Exception {
}
class LibroNonEsistente extends Exception {
}

public class Biblioteca {
 private TreeMap<Integer, Libro> libri;

// costruttore
public Biblioteca() {
 libri = new TreeMap<Integer, Libro>();
}

// aggiunta libro
public void aggiungiLibro(Libro libro) throws LibroEsistente {
 if (!libri.containsKey(libro.getCodice())) // verifica duplicato
   libri.put(libro.getCodice(), libro.clone()); // inserimento
 else
     throw new LibroEsistente();
}

// eliminazione libro
public void eliminaLibro(int codice) throws LibroNonEsistente {
 if (libri.containsKey(codice)) // verifica esistenza chiave
   libri.remove(codice); // rimozione
 else
     throw new LibroNonEsistente();
}

// ricerca libro a partire dal codice
public Libro trovaLibro(int codice) throws LibroNonEsistente {
 if (libri.containsKey(codice)) // verifica esistenza chiave
   return libri.get(codice).clone(); // accesso diretto elemento
 else
     throw new LibroNonEsistente();
}

// ricerca libro a partire dal titolo
public Libro trovaLibro(String titolo) throws LibroNonEsistente {
 for (Libro libro : libri.values()) // scorrimento con iteratore
    if (libro.getTitolo().equals(titolo)) // verifica elemento
      return libro.clone();
 throw new LibroNonEsistente();
}

// ricerca libri a partire dall’autore
public ArrayList<Libro> trovaLibri(String autore) {
 ArrayList<Libro> libri_autore = new ArrayList<Libro>(libri.size());
 
 for (Libro libro : libri.values()) // scorrimento con iteratore
    if (libro.getAutore().equals(autore)) // verifica elemento
 libri_autore.add(libro.clone());
 libri_autore.trimToSize();
 return libri_autore;
}
}
