
import java.util.*;

class NessunCliente extends Exception {}
class ClienteEsistente extends Exception {}

class Cliente {
    
    private int codice;
    private String cognome;
    private String nome;
    private String telefono;
    private String indirizzo;
    private String citta;

    public Cliente(int codice, String cognome, String nome, String telefono, String indirizzo, String citta) {
        this.codice = codice;
        this.cognome = cognome;
        this.nome = nome;
        this.telefono = telefono;
        this.indirizzo = indirizzo;
        this.citta = citta;          
    }

    public Cliente(Cliente c) {
        this.codice = c.codice;
        this.cognome = c.cognome;
        this.nome = c.nome;
        this.telefono = c.telefono;
        this.indirizzo = c.indirizzo;
        this.citta = c.citta;
    }

    public int getCodice() {
        return codice;
    }

    public String getCognome() {
        return cognome;
    }

    public String getNome() {
        return nome;
    }

    public String getTelefono() {
        return telefono;
    }
    
    public String getIndirizzo() {
        return indirizzo;
    }
    
    public String getCitta() {
        return citta;
    }
}


public class Clienti {
    
private HashMap<String, Cliente>elenco;

    public Clienti() {
        elenco = new HashMap<String, Cliente>();
    }
    
    public void aggiungiCliente(int codice, String cognome, String nome, String telefono, String indirizzo, String citta) throws ClienteEsistente {
        Cliente tmp = new Cliente(codice, cognome, nome, telefono, indirizzo, citta);
        
        if (elenco.containsKey(telefono)) throw new ClienteEsistente();
        elenco.put(telefono, tmp);
    }
    
    public Cliente trovaCliente(String telefono) throws NessunCliente {
        Cliente tmp = (Cliente)elenco.get(telefono);
        
        if (tmp == null) throw new NessunCliente();
        return new Cliente(tmp);
    }

    public Cliente cercaCliente(int codice) throws NessunCliente {
        Iterator<Cliente> it = elenco.values().iterator();
        Cliente tmp;
        
        while (it.hasNext()) {
             tmp = it.next();
             if (tmp.getCodice() == codice)
               return new Cliente(tmp);
        }
        throw new NessunCliente();
    }
    
    public void rimuoviCliente(int codice) throws NessunCliente {
        Iterator<Cliente> it = elenco.values().iterator();
        Cliente tmp;
        
        while (it.hasNext()) {
             tmp = it.next();
             if (tmp.getCodice() == codice) {
                it.remove();
                return;
             }
        }
        throw new NessunCliente();
    }
}