
// classe parametrica Coda: gli attributi "head" e "tail" hanno come tipo generico la classe parametrica Nodo (Nodo<T>)
public class Coda<T> {
 private Nodo<T> head;
 private Nodo<T> tail;

public Coda() {
 head = null;
 tail = null;
}

private Nodo<T> creaNodo(T info, Nodo<T> link) {
 Nodo<T> p = new Nodo<T>(info);
 
 p.setLink(link);
 return p;
}

// inserimento di un elemento di tipo parametrico nella coda
public void enqueue(T info) {
 Nodo<T> p = creaNodo(info, null);
 
 if (head == null) {
   tail = p;
  head = tail;
 }
else {
      tail.setLink(p);
      tail = p;
    }
}

// estrazione di un elemento di tipo parametrico dalla coda
public T dequeue() {
 Nodo<T> p;

 if (head == null)
   return null;
 p = head;
 head = head.getLink();
 if (head == null)
   tail = null;
 return p.getInfo();
}

public Iteratore<T> getIteratore() {
 Iteratore<T> i = new Iteratore<T>(head);
 return i;
}

public static double somma(Coda<? extends Number> coda) {
 double s = 0.0;
 Iteratore<? extends Number> i = coda.getIteratore();
 while (i.hasNext()) {
      s = s + i.next().doubleValue();
 }
 return s;
}

public void copyFrom(Coda<? extends T> coda) {
 Iteratore<? extends T> i = coda.getIteratore();
 while (i.hasNext()) {
      this.enqueue(i.next());
 }
}

public void copyTo(Coda<? super T> coda) {
 Iteratore<T> i = this.getIteratore();
 while (i.hasNext()) {
      coda.enqueue(i.next());
 }
}

public static void main (String args[]) {
 Coda<Number> cn = new Coda<Number>();
 Coda<Integer> ci = new Coda<Integer>();
 Coda<Double> cd = new Coda<Double>();

 ci.enqueue(-1);
 ci.enqueue(99);
 cd.enqueue(3.1416);
 cd.enqueue(1.4142);
 cn.copyFrom(ci);
 cn.copyFrom(cd);
 double s = Coda.somma(cn);
 System.out.println(s);
 ci.copyTo(cn);
 cd.copyTo(cn);
 s = Coda.somma(cn);
 System.out.println(s);
} 
}
