
package container;

import java.io.IOException;
import java.util.Iterator;

public class Deposito_ferroviario extends Deposito {
    
    private boolean compreso(int codice, int codici[]) {
        for (int i=0; i<codici.length; i++)
           if (codice == codici[i])
             return true;
        return false;
    }
    
    public Deposito_ferroviario() {
        super();
    }
    
    public int caricaTreno(Treno treno, int codici[]) {
        int contatore = 0;
        Container tmp;
        
        for (Iterator<Container> it = deposito.values().iterator(); it.hasNext();) {
           tmp = it.next();
           if (compreso(tmp.getCodice(), codici)) {
             treno.carica(tmp);
             it.remove();
             contatore++;
           }
        }        
        return contatore;
    }
    
    public int scaricaTreno(Treno treno, int posizioni[]) throws EccezioneDeposito, EccezioneTreno {
        Container container;
        int contatore;
        
        if (treno.numeroContainer() != posizioni.length)
          throw new EccezioneDeposito();
        
        for (contatore=0; contatore<posizioni.length; contatore++) {
           container = treno.scarica();
           this.ingresso(container, posizioni[contatore]);
        }
     return contatore;
    }
    
    public static void main (String args[]) throws IOException, ClassNotFoundException {
        Deposito_ferroviario deposito = new Deposito_ferroviario();
        Treno treno_partenza = new Treno();;
        Treno treno_arrivo = new Treno();
        Container c;
        int posizioni[] = new int[3];
        posizioni[0] = 1;
        posizioni[1] = 10;
        posizioni[2] = 100;
        int codici[] = new int[2];
        codici[0] = 123;
        codici[1] = 789;
        
        Container c1 = new Container(123, 50);
        c1.setCarico(45);
        treno_arrivo.carica(c1);
        Container c2 = new Container(456, 25);
        c2.setCarico(20);
        treno_arrivo.carica(c2);
        Container_frigo c3 = new Container_frigo(789, 40);
        c3.setTemperatura(-20);
        c3.setCarico(40);
        treno_arrivo.carica(c3);
        
        System.out.println("Container su treno: "+treno_arrivo.numeroContainer());
        
        try {
             deposito.scaricaTreno(treno_arrivo, posizioni);
        }
        catch (EccezioneTreno e) {
            System.out.println("Eccezione treno");
        }
        catch (EccezioneDeposito e) {
            System.out.println("Eccezione deposito");
        }
        
        System.out.println("Carico totale: "+deposito.caricoTotale());
        System.out.println("Carico refrigerato: "+deposito.caricoFrigo());
        
        try {
             c = deposito.ricerca(789);
             System.out.println(c);
        }
        catch (EccezioneDeposito e) {
            System.out.println("Eccezione ricerca");
        }
        
        deposito.salvaSuFile("deposito.bin");
        
        deposito.caricaTreno(treno_partenza, codici);
               
        System.out.println("Carico totale: "+deposito.caricoTotale());
        System.out.println("Carico refrigerato: "+deposito.caricoFrigo());
        
        deposito.caricaDaFile("deposito.bin");
                
        System.out.println("Carico totale: "+deposito.caricoTotale());
        System.out.println("Carico refrigerato: "+deposito.caricoFrigo());
    }
}
