
import java.lang.*;
import java.util.*;

class TroppiDipendenti extends Exception {
}
class DipendenteSconosciuto extends Exception {
}

public class Dipendenti {
 public final static int NUMERO_MASSIMO_DIPENDENTI = 1000;
 private ArrayList<Dipendente> dipendenti; // contenitore

// costruttore
public Dipendenti() {
 dipendenti = new ArrayList<Dipendente>(NUMERO_MASSIMO_DIPENDENTI);
}

// aggiunta dipendente
public void aggiungiDipendente(Dipendente dipendente) throws TroppiDipendenti {
 if (dipendenti.size() >= NUMERO_MASSIMO_DIPENDENTI)
   throw new TroppiDipendenti();
 dipendenti.add(dipendente.clone()); // inserimento nel contenitore
}

// eliminazione dipendente
public void eliminaDipendente(String nominativo) throws DipendenteSconosciuto {
 Iterator<Dipendente> i; // iteratore
 
 for (i=dipendenti.iterator(); i.hasNext();) {
    Dipendente dipendente = i.next();
    if (dipendente.getNominativo().equals(nominativo)) {
      i.remove(); // eliminazione dal contenitore
      return;
    }
 }
 throw new DipendenteSconosciuto();
}

// ricerca dipendente
public Dipendente cercaDipendente(String nominativo)throws DipendenteSconosciuto {
 // ciclo for-each
 for (Dipendente dipendente : dipendenti) {
    if (dipendente.getNominativo().equals(nominativo))
      return dipendente.clone();
 }
 throw new DipendenteSconosciuto();
}

// elenco dipendenti
public String elencoDipendenti() {
 String elenco = "";
 
 // ciclo for-each
 for (Dipendente dipendente : dipendenti) {
    elenco += dipendente.getNominativo()+" "+dipendente.getSesso()+" "+dipendente.getIndirizzo();
    if (dipendente instanceof Impiegato)
      elenco += " " + ((Impiegato)(dipendente)).getUfficio();
    if (dipendente instanceof Docente)
      elenco += " " + ((Docente)(dipendente)).getDisciplina();
    elenco += "\r\n"; // fine riga
 }
 return elenco;
}
}
