
import java.io.*;
import java.util.*;


public class Motoveicoli {
    protected HashMap<String, Motoveicolo> elenco;
    
    public Motoveicoli() {
        elenco = new HashMap<String, Motoveicolo>();
    }
    
    public void addMotoveicolo(String targa, String marca, String modello, int anno, int cilindrata, String colore, Boolean scooter, int ruote) throws MotoveicoliException {
       
         if ((elenco.containsKey(targa)))
          throw new MotoveicoliException();
        
         Motoveicolo tmp = new Motoveicolo(marca, modello, anno, cilindrata, colore, scooter, ruote);
        
        elenco.put(targa, tmp);
    }
    
    public Motoveicolo getMotoveicolo(String targa) throws MotoveicoliException {
        if (!(elenco.containsKey(targa)))
          throw new MotoveicoliException();
        
        Motoveicolo tmp = elenco.get(targa);
        return tmp;
    }
    
    public void modMotoveicolo(String targa, String marca, String modello, int anno, int cilindrata, String colore, Boolean scooter, int ruote) throws MotoveicoliException {
        
        if (!(elenco.containsKey(targa)))
          throw new MotoveicoliException();
        
        Motoveicolo tmp = new Motoveicolo(marca, modello, anno, cilindrata, colore, scooter, ruote);
        
        elenco.put(targa, tmp);
    }
    
    public void delMotoveicolo (String targa) throws MotoveicoliException {
        
        if (!(elenco.containsKey(targa)))
          throw new MotoveicoliException();
        
        elenco.remove(targa);
    }
    
    public void save() throws IOException {
        FileOutputStream file = new FileOutputStream("moto.data");
        ObjectOutputStream output = new ObjectOutputStream(file);
        output.writeObject(elenco);
        file.close();
    }
    
    public void load() throws IOException, ClassNotFoundException {
        FileInputStream file = new FileInputStream("moto.data");
        ObjectInputStream input = new ObjectInputStream(file);
        elenco = (HashMap<String, Motoveicolo>)input.readObject();
        file.close();
    }
}
