
class Nodo<T>  {
 private T info;
 private Nodo link;

 public Nodo(T info){
  this.info = info;
  link=null;
 }

 public void setInfo(T info){
  this.info = info;
 }

 public T getInfo(){
  return info;
 }
 
 protected void setLink(Nodo<T> link){
  this.link = link;
 }

 public Nodo<T> getLink(){
  return link;
 }
}

public class Pila<T> {
 private Nodo<T> head;

public Pila(){
 head = null;
}

private Nodo creaNodo(T info, Nodo<T> link){
 Nodo<T> p = new Nodo<T>(info);
 p.setLink(link);
 return p;
}

public void push(T info){
 Nodo<T> p;
 p = creaNodo(info, head);
 head = p;
}

public T pop(){
 Nodo<T> p;
 if (head==null)
   return null;
 p = head;
 head = head.getLink();
 return p.getInfo();
}

public static void main (String[] args){
 Punto p1 = new Punto(1,1);
 Punto p2 = new Punto(0,0);
 Pila<Punto>  p = new Pila<Punto>();
 p.push(p1);
 p.push(p2);
 
 Punto x=(p.pop());
 if (x==null)
   System.out.println("Pila p vuota");
 else
     System.out.println(x.toString());
 x=(p.pop());
 if (x==null)
   System.out.println("Pila p vuota");
 else
     System.out.println(x.toString());
 x=(p.pop());
 if (x==null)
   System.out.println("Pila p vuota");
 else
     System.out.println(x.toString());
 }
}
