
import java.util.*;

class NumeroInesistente extends Exception {}

class Telefonata {
    private String numero;
    private Date dataOra;
    private int codiceDipendente;

    public Telefonata(String numero, Date dataOra, int codiceDipendente) {
        this.numero = numero;
        this.dataOra = dataOra;
        this.codiceDipendente = codiceDipendente;
    }

    public Date getDataOra() {
        return dataOra;
    }

    public String getNumero() {
        return numero;
    }
    
    public int getCodiceDipendente() {
        return codiceDipendente;
    }
}


public class Telefonate {
    private HashMap<String, Telefonata> registro;
    
    public void Telefonate() {
        registro = new HashMap<String, Telefonata>();
    }

    public void aggiungiTelefonata(String numero, Date dataOra, int codiceDipendente) {
        Telefonata tmp = new Telefonata(numero, dataOra, codiceDipendente);
        
        registro.put(numero, tmp);
    }
    
    public Telefonata trovaTelefonata(String numero) throws NumeroInesistente {
        Telefonata tmp = registro.get(numero);
        
        if (tmp == null)
            throw new NumeroInesistente();
        else
            return tmp;
    }
}
